/**
服务端
public function editAvater(){
    !R("Home/Auth/userCheck",array(I('request.user_id'),I('request.user_hash'))) && exit();  // 校验用户身份

    if(IS_POST){
        $user_id   = I('post.user_id');
        $user_auth = I('post.user_auth');

        $upload = new \Think\Upload();
        $upload->maxSize = 3145728;
        $upload->exts = array('jpg','gif','png','jpeg');
        $upload->rootPath = './Uploads/';
        $upload->savePath = '';
        $upload->saveName = md5();

        $info = $upload->upload();
        if (!$info) {
            $res = array("status" => 0);
            $this->ajaxReturn( $this->error($upload->getError()));
        } else {
            // 裁切头像
            $image = new \Think\Image();
            $image->open( $upload->rootPath.$info["pic"]["savepath"].$info["pic"]["savename"] );
            $save_path = $upload->rootPath.$info["pic"]["savepath"].$info["pic"]["savename"];
            $image->thumb(200,200,\Think\Image::IMAGE_THUMB_CENTER)->save($save_path);

            // $data['user_avatar'] = $info["pic"]["savepath"].$info["pic"]["savename"];
            // $result = M('user')->where(array('user_id'=>$user_id))->save($data);
            // if($result){
            //     $res = array("status" => 1,"path" =>$info["pic"]["savepath"].$info["pic"]["savename"]);
            //     $this->ajaxReturn($res,"json");
            // }
            $res = array("status" => 1,"path" =>$info["pic"]["savepath"].$info["pic"]["savename"]);
            $this->ajaxReturn($res,"json");
        }
    }
}
*/
/* 调用
onclick="upload()"
function upload(){
    ImgUpload.uploadUrl = getUrlNock()+'Index/imageUpload.html';
    ImgUpload.success   = function imageUpload(res){
        dump(res);
    }
    ImgUpload.openAlbum();
}
*/
ImgUpload = {};
ImgUpload.actionSheet = function(){
    api.actionSheet({title:'选择图片来源',buttons:['拍照','从手机相册中选择']},function(ret,err){
        var index = ret.buttonIndex;
        if( ret.buttonIndex == 1 ){
            ImgUpload.openCamera();
        } else if( ret.buttonIndex == 2 ){
            ImgUpload.openAlbum();
        } else {
            return false;
        }
    });
}
ImgUpload.openCamera = function(){
    api.getPicture({
        sourceType : "camera",
        encodingType : "jpg",
        destinationType : "url",
        mediaValue : "pic",
        quality : 50,
        saveToPhotoAlbum : true
    }, function(ret, err) {
        if (ret && ret.data) {
            // 拍照返回的本地路径
            var returnUrl   = ret.data;
            // 图片压缩
            ImgUpload.imgCompress(returnUrl, 0.5, 0.5, ImgUpload.getExt(returnUrl), function(compressImg) {
                var data = {files:{"pic":compressImg},values:{user_id:__UID__,user_hash:__UHASH__,'type':1}};
                ImgUpload.uploadFile(ImgUpload.uploadUrl, data, function(res) {
                    // callback(res);
                });
            });
        }
    });
}
ImgUpload.openAlbum = function(){
    uiMediaScanner = api.require('UIMediaScanner');
    imageFilter = api.require("imageFilter");
    isIOS = api.systemType == "ios" ? true : false;

    uiMediaScanner.open({
        type:'picture',
        column:4,
        classify:true,
        max:1,
        sort:{key:'time',order:'desc'},
        texts:{stateText:'',cancelText:'取消',finishText:'选择'},
        styles:{
            bg:'#fff',
            mark:{icon:'',position:'bottom_left',size:20},
            nav:{
                bg          : '#24a5ff',
                stateColor  : '#ffda44',
                stateSize   : 20,
                cancelBg    : 'rgba(0,0,0,0)',
                cancelColor : '#fff',
                cancelSize  : 20,
                finishBg    : 'rgba(0,0,0,0)',
                finishColor : '#fff',
                finishSize  : 20
            }
        }
    }, function(ret) {
        if (ret) {
            for (var i = 0; i < ret.list.length; i++) {
                var selectImg = ret.list[i];
                // 获取图片的路径
                var selectimgPath = selectImg.path;
                var selectimgThumbPath = selectImg.thumbPath;
                // IOS需要将虚拟路径转换为本地路径才可以压缩
                if (isIOS) {
                    // 转换为真实路径
                    uiMediaScanner.transPath({path:selectimgPath},function(transObj){
                        // 图片压缩
                        ImgUpload.imgCompress(transObj.path, 0.5, 0.5, selectImg.suffix, function(compressImg) {
                            var data = {files:{"pic":compressImg},values:{user_id:__UID__,user_hash:__UHASH__,'type':1}};
                            ImgUpload.uploadFile(ImgUpload.uploadUrl, data, function(res) {
                                // callback(res);
                            });
                        });
                    });
                } else {
                    ImgUpload.imgCompress(selectimgPath,0.5,0.5,selectImg.suffix,function(compressImg){
                        var data = {files:{"pic":compressImg},values:{user_id:__UID__,user_hash:__UHASH__,'type':1}};
                        ImgUpload.uploadFile(ImgUpload.uploadUrl, data, function(res) {
                            // callback(res);
                        });
                    });
                }
            }
        }
    });
}
ImgUpload.NewGuid = function(){
    function S4() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    }
    return (S4()+S4()+"-"+S4()+"-"+S4()+"-"+S4()+"-"+S4()+S4()+S4());
}

ImgUpload.getNowFormatDate = function(){
    var date = new Date();
    var seperator1 = "-";
    var year = date.getFullYear();
    var month = date.getMonth() + 1;
    var strDate = date.getDate();
    if (month >= 1 && month <= 9) {
        month = "0" + month;
    }
    if (strDate >= 0 && strDate <= 9) {
        strDate = "0" + strDate;
    }
    var currentdate = year + seperator1 + month + seperator1 + strDate
    return currentdate;
}
// 获取文件拓展名
ImgUpload.getExt = function(fileName) {
    return fileName.substring(fileName.lastIndexOf('.') + 1);
}

ImgUpload.imgCompress = function(imgsrc, quality, scale, ext, callback) {
    var savePath = api.cacheDir + "/" + ImgUpload.getNowFormatDate() + "/";
    var savename = ImgUpload.NewGuid() + "." + ext;
    imageFilter.compress({
        img     : imgsrc,
        quality : quality,
        scale   : quality,
        save    : {album : false, imgPath : savePath, imgName : savename}
    }, function(ret, err) {
        if (ret) {
            callback(savePath + savename);
        } else {
            alert(JSON.stringify(err));
        }
    });
}

ImgUpload.uploadFile = function(url, data, callback) {
    api.ajax({
        url : url,
        method : 'post',
        timeout : 30,
        dataType : 'json',
        returnAll : false,
        data : data
    }, function(ret, err) {
        if (ret) {
            if (ret.status == 1) {
                ImgUpload.success(ret);
            } else if (ret.status == 0) {
                alert(ret.info);
            }
        } else {
            api.alert({
                msg : ('错误码：' + err.code + '；错误信息：' + err.msg + '；网络状态码：' + err.statusCode)
            });
        }
    });
}
