// 倒计时
var wait = 60;
function time(o) {
    if (wait == 0) {
        o.removeAttribute("disabled");
        $(o).removeClass('button-gray');
        $(o).addClass('button');
        $(o).html("获取验证码");
        wait = 60;
    } else {
        o.setAttribute("disabled", true);
        $(o).removeClass('button');
        $(o).addClass('button-gray');
        $(o).html("重新发送(" + wait + ")");
        wait--;
        setTimeout(function() {
            time(o)
        },
        1000)
    }
}

// 图片验证码 apicloud云端 接口
function addImage(){
    var cap = new Captcha(getAppId(),getAppKeyInSha1());
    cap.getImage(function(err,img){
        if(err) return;
        $("#imgcap").html(img);
    })
}
// 短信验证码
function getSmsCode(obj,mobile_id,type){
	if($("#verify_data").val() != $("#verify img").attr("data")) {
		api.toast({msg: '图片验证码错误',duration:2000, location: "botoom"})
		return false;
	}
    // 验证手机号格式
    var partten = /^1[3|4|5|8][0-9]\d{4,8}$/;
    if($('#'+mobile_id).val() == ''){
        api.toast({msg: '请填写手机号',duration:2000, location: "botoom"})
        $('#'+mobile_id).focus();
        return false;
    }
    if (!partten.test($('#'+mobile_id).val())) {
        api.toast({msg: '手机号格式错误',duration:2000, location: "botoom"})
        $('#'+mobile_id).focus();
        return false;
    }
    // 判断是否处于等待状态
    if ($(obj).attr('disabled') == 'disabled'){
        return false;
    } else {
        api.ajax({
            url: getUrlNock()+'index.php/Index/sendSms.html',
            method: 'post',
            dataType:'JSON',
            timeout:60000,
            data: {values:{'mobile_id':$('#'+mobile_id).val(),'type':type}},
        },function(ret,err){
            if(ret.ret == 1){
                api.toast({msg:'短信发送成功',duration:2000, location: "botoom"});
                time(obj);
            } else {
                api.toast({msg:ret.err,duration:2000, location: "botoom"});
            }
        });
    }
}
// 注册
function register(){
    if($("input[type='checkbox']").is(':checked') == false){
        api.toast({msg: '请同意服务条款',duration:2000, location: "botoom"})
    } else {
        var account    = $("#mobile").val();
        var verify     = $("#mobile_verify").val();
        var nickname   = $("#nickname").val();
        var password   = $("#password").val();
        var repassword = $("#repassword").val();
        data = {values:{'account':account,'verify':verify,'nickname':nickname,'password':password,'repassword':repassword}};
        url  = 'index.php/Index/register.html';
        postData(url,data);
    }
}
function getBackPassword(){
    var account    = $("#mobile").val();
    var verify     = $("#mobile_verify").val();
    var nickname   = $("#nickname").val();
    var password   = $("#password").val();
    var repassword = $("#repassword").val();
    data = {values:{'account':account,'verify':verify,'nickname':nickname,'password':password,'repassword':repassword}};
    url  = 'index.php/Index/getBackPassword.html';
    postData(url,data);
}

// 登录
function login(){
    var account    = $("#mobile").val();
    var password   = $("#password").val();
    data = {values:{'account':account,'password':password}};
    url  = 'index.php/Index/login.html';
    postData(url,data);
}
function selectedRadio(obj,id){
    $(obj).attr("checked",'checked');
    $("#"+id).removeAttr("checked");
}
